/* eslint-disable camelcase */
const UserModel = require('../../../models/UserModel')
const jwt = require('jsonwebtoken')

const setUserType = async (req, res, next) => {
  try {
    const { user_type } = req.body
    if (!user_type || !['user', 'employer'].includes(user_type)) {
      return res.status(422).json({
        error: true,
        message: 'نوع یوزر معتبر نیست'
      })
    }

    // جستجوی کاربر با شماره موبایل ارسالی
    const token = req.header('Authorization').split(' ')[1]
    if (!token) return res.status(401).send('Access Denied')

    const decodedToken = jwt.verify(token, process.env.APP_SECRET)
    const user = await UserModel.findById(decodedToken.id)

    if (!user) {
      return res.status(404).json({
        error: true,
        message: 'کاربری با این شماره موبایل یافت نشد'
      })
    }

    // آپدیت نوع یوزر
    user.user_type = user_type.toLowerCase()
    await user.save()

    return res.json({
      message: 'نوع کاربر با موفقیت به‌روزرسانی شد',
      id: user._id
    })
  } catch (error) {
    next(error)
  }
}

module.exports = {
  setUserType
}
